#!/usr/bin/perl

#=============================================================================
# clippic_mail.pl: pop & ftp program of clippic (ver.20040313)
#
# Copyright (C) 2004 OHKUBO Masahiko <mah@pobox.ne.jp>
# The latest version is available here: http://mah.pobox.ne.jp/clippic.shtml
#=============================================================================

use strict;
use vars '%setting';

BEGIN {
	my($path, $tmp);

	# ץबǥ쥯ȥĴ٤
	$path = $0;
	if (index($path, '\\') > -1) {
		# ڤ \ ȤĶ?
		$path =~ s/\\/\//g;
	}
	if (index($path, '/') > -1) {
		# ڤ / ȤĶ?
		$path =~ /(.*)\/(.*)$/;
		$setting{'file_program'} = $2;
		if ($1 ne '') {
			$setting{'dir_program'} = $1 . '/';
		} else {
			$setting{'dir_program'} = './';
		}
	} else {
		# Ƚ̤ǤʤĶ
		$setting{'file_program'} = $path;
		$setting{'dir_program'} = './';
	}
	require $setting{'dir_program'} . 'clippic_common.pl'; #<perl2exe_comment>
	require $setting{'dir_program'} . 'jcode.pl'; #<perl2exe_comment>
	require $setting{'dir_program'} . 'mimer.pl'; #<perl2exe_comment>
	require $setting{'dir_program'} . 'mimew.pl'; #<perl2exe_comment>
#	require './clippic_common_win32.pl'; #<perl2exe_execute>
#	require './jcode.pl'; #<perl2exe_execute>
#	require './mimer.pl'; #<perl2exe_execute>
#	require './mimew.pl'; #<perl2exe_execute>
	unshift(@INC, substr($setting{'dir_program'}, 0, -1)); #<perl2exe_comment>
	require 5.004;
}
use Net::POP3;
use Net::FTP;

&MAIN();
exit;



# ᥤ롼
sub MAIN {
	my($ref_setting_mail, $ref_flag_convert);
	my($flag, %flag_success);
	my(@tmp, $tmp, $counter);

	# Ƽͤ
	&SECTION_SET_SETTING();
	# եɤ߹
	($ref_setting_mail, $ref_flag_convert) = &SECTION_READ_CONFIGFILE_MAIL($setting{'dir_data'} . $setting{'file_data'});
	if ($setting{'mode'} eq 'stdin') {
		# ᡼ɸϥ⡼
		$flag = &SECTION_PROCESS_MAIL($setting{'file_input'}, $ref_setting_mail, $setting{'dir_data'} . $setting{'dir_data_pop'});
#		if ($flag eq 'yes') {
			$flag_success{'input'} = 'yes';
			$flag_success{'output'} = 'yes';
#		}
	} else {
		# POP 饤ȥ⡼
		$flag = &SECTION_RECEIVE_MAIL($ref_setting_mail, $setting{'dir_data'} . $setting{'dir_data_pop'});
#		if ($flag eq 'yes') {
			$flag_success{'input'} = 'yes';
			$flag_success{'output'} = 'yes';
#		}
	}
	@tmp = ('input', 'output');
	while(@tmp) {
		$tmp = shift(@tmp);
		if (($$ref_flag_convert{$tmp} eq 'yes') && ($flag_success{$tmp} eq 'yes')) {
			$counter ++;
		} else {
			$$ref_flag_convert{$tmp} = 'no';
		}
	}
	if ($counter > 0) {
		# password () 򾯤ФѴƤ
		&SAVE_CONFIGFILE_MAIL($setting{'dir_data'} . $setting{'file_data'}, $ref_flag_convert);
	}
	return;
}



# : Ƽꤹ
sub SECTION_SET_SETTING {
	my(%setting_default, %setting_cmdline);
	my($key);

	# ǥեͤȥޥɥ饤󥪥ץɤ߹
	%setting_default = %{&SET_SETTING_DEFAULT('mail')};
	%setting_cmdline = %{&READ_CMDLINE(\@ARGV)};
	# ̰: $setting{'verbose_level_*'} ط
	if ($setting_cmdline{'debug'} eq 'yes') {
		$setting{'verbose_level_stdout'} = 2;
		$setting{'verbose_level_log'} = 2;
	} elsif ($setting_cmdline{'quiet'} eq 'yes') {
		$setting{'verbose_level_stdout'} = 0;
	} elsif ($setting_cmdline{'debug_log'} eq 'yes') {
		$setting{'verbose_level_stdout'} = 0;
		$setting{'verbose_level_log'} = 2;
	}
	# ץ೫ϥå
	&VERBOSE('normal', 'nothing', $setting{'program_name'} . ' (ver.' . $setting{'program_version'} . ') by ' . $setting{'program_author'});
	# ̰: $setting{'dir_data'} ط
	if (exists($setting_cmdline{'dir_data'})) {
		# ޥɥ饤ˤ
		if (substr($setting_cmdline{'dir_data'}, -1, 1) ne '/') {
			#  / դƤʤäդ
			$setting_cmdline{'dir_data'} = $setting_cmdline{'dir_data'} . '/';
		}
		$setting{'dir_data'} = $setting_cmdline{'dir_data'};
	} else {
		$setting{'dir_data'} = $setting{'dir_program'};
	}
	# ̰: $setting{'file_log'} ط
	if (exists($setting_cmdline{'file_log'})) {
		# ޥɥ饤ˤ
		if (index($setting_cmdline{'file_log'}, '/') == -1) {
			# / ޤޤƤʤ硤롼Ȥ $setting{'dir_data'} 
			$setting{'file_log'} = $setting_cmdline{'dir_data'} . $setting_cmdline{'file_log'};
		}
	} else {
		$setting{'file_log'} = $setting{'dir_data'} . $setting_default{'file_log'};
	}
	# %setting ˥ԡ (ͥ: %setting_cmdline%setting_default)
	while (($key, undef) = each(%setting_default)) {
		if (exists($setting_cmdline{$key})) {
			$setting{$key} = $setting_cmdline{$key};
		} else {
			if (exists($setting{$key})) {
				# ץˤ
			} else {
				# ǥեͤˤ
				$setting{$key} = $setting_default{$key};
			}
		}
	}
	&CHECK_DEFINITION('commandline', \%setting_default, \%setting_cmdline);
	# %setting ˥ԡ (ͥ: %setting_cmdline%setting)
	while (($key, undef) = each(%setting_default)) {
		if (exists($setting_cmdline{$key})) {
			# ޥɥ饤ˤ
			$setting{$key} = $setting_cmdline{$key};
			&VERBOSE('detail', 'detail', 'SET: ' . $key . ' = ' . $setting{$key} . ' (by commandline)');
		} elsif ($setting{$key} eq $setting_default{$key}) {
			# ǥեͤˤ
			&VERBOSE('detail', 'detail', 'SET: ' . $key . ' = ' . $setting{$key} . ' (by default)');
		} else {
			# ץˤ
			&VERBOSE('detail', 'detail', 'SET: ' . $key . ' = ' . $setting{$key} . ' (by program)');
		}
	}
	return;
}



# : եɤ߹
sub SECTION_READ_CONFIGFILE_MAIL {
	my($file_mail) = @_;
	my($file_rename, %setting_mail);
	my(%flag, $tmp);
	my(@section) = ('input', 'output');

	# եɤ߹ (Ĥϥåɬ)
	if (-e ($file_mail)) {
		$file_rename = &LOCK_FILE($file_mail);
		%setting_mail = %{&LOAD_CONFIGFILE($file_rename, 'direct')};
		&UNLOCK_FILE($file_rename);
	} else {
		&VERBOSE('error', 'error', 'ERROR: file not found. / file = ' . $file_mail);
	}
	while(@section) {
		$tmp = shift(@section);
		if ($setting_mail{'password:' . $tmp} ne '') {
			# password ιԤ¸ߤ   password_crypted ˽񤭴
			$flag{$tmp} = 'yes';
		} elsif ($setting_mail{'password_crypted:' . $tmp} ne '') {
			$setting_mail{'password:' . $tmp} = &DECRYPT_PASSWORD($setting_mail{'password_crypted:' . $tmp});
		}
	}
	return(\%setting_mail, \%flag);
}



# : ᡼ϤƾˤäȤźղ FTP 
sub SECTION_PROCESS_MAIL {
	my($file_input, $ref_setting_mail, $dir) = @_;
	my($tmp, @text, $file_local);
	my($ref_header, $ref_text, $ref_filename, $ref_data);
	my($condition, $server, $port, $passive, $username, $password, $directory_image, $filename_image, $directory_text, $filename_text, $file_image_latest, $file_text_latest, $file_text_latest_template, $file_text_latest_jcode);	# for FTP
	my($counter, $filename, $flag, $ftp, $ref_tmp);

	if ($file_input ne '') {
		# ᡼ե뤫
		$/ = undef;
		open(FILE, $file_input);
		$tmp = <FILE>;
		close(FILE);
		$/ = "\n";
	} else {
		# ᡼ɸϤ
		read(STDIN, $tmp, $setting{'input_byte_max'});
	}
	$tmp =~ s/\x00//g;
	&VERBOSE('normal', 'normal', 'INPUT(header+body): byte = '. length($tmp));
	@text = split("\n", ${(&CONVERT_EUC(\$tmp))[0]});
	# ᡼إåȴФ
	($ref_header, $ref_text) = &EXTRACT_HEADER(\@text, $setting{'mail_address_regex'});
	# ѿ
	$condition = $$ref_setting_mail{'condition:input'};
	$server = $$ref_setting_mail{'server:output'};
	$port = $$ref_setting_mail{'port:output'};
	$passive = $$ref_setting_mail{'passive:output'};
	$username = $$ref_setting_mail{'username:output'};
	$password = $$ref_setting_mail{'password:output'};
	$directory_image = $$ref_setting_mail{'directory_image:output'};
	$filename_image = $$ref_setting_mail{'filename_image:output'};
	$directory_text = $$ref_setting_mail{'directory_text:output'};
	$filename_text = $$ref_setting_mail{'filename_text:output'};
	$file_image_latest = $$ref_setting_mail{'file_image_latest:output'};
	$file_text_latest = $$ref_setting_mail{'file_text_latest:output'};
	$file_text_latest_template = $$ref_setting_mail{'file_text_latest_template:output'};
	$file_text_latest_jcode = $$ref_setting_mail{'file_text_latest_jcode:output'};
	# ͤ
	if (!($directory_image =~ /\/$/)) {
		$directory_image .= '/';
	}
	$directory_image .= '<YYYY><MM>/';
	if (!($directory_text =~ /\/$/)) {
		$directory_text .= '/';
	}
	$directory_text .= '<YYYY><MM>/';
	# å
	if (&CHECK_HEADER_CONDITION($ref_header, $condition) eq 'no') {
		# ˤʤ᡼ǤϤʤä
		&VERBOSE('detail', 'detail', 'UNMATCH: subject=' . $$ref_header{'SUBJECT'} . '; from=' . $$ref_header{'FROM'} . '; to=' . $$ref_header{'TO'} . ';');
	} else {
		# ˤʤ᡼  ɬפʬȴФ
		&VERBOSE('normal', 'normal', 'MATCH: subject=' . $$ref_header{'SUBJECT'} . '; from=' . $$ref_header{'FROM'} . '; to=' . $$ref_header{'TO'} . ';');
		($ref_text, $ref_filename, $ref_data) = &EXTRACT_PLAINTEXT_ATTACHMENT($ref_header, $ref_text, $setting{'mail_address_regex'});
		if (ref($ref_filename) eq 'ARRAY') {
			# ƥե뷲
			&CHECK_DIR($dir, oct('700'));
			while(@$ref_filename) {
				&CHECK_MODULE('Net::FTP'); #<perl2exe_comment>
				$counter ++;
				$filename = shift(@$ref_filename);
				($flag, $ftp) = &FTP_OPEN($server, $port, $passive, $username, $password);
				if ($flag eq 'yes') {
					($filename, $directory_image, $filename_image, $directory_text, $filename_text, $file_image_latest, $file_text_latest) = &REPLACE_STRING_CONFIG($counter, $filename, $$ref_header{'DATE'}, $directory_image, $filename_image, $directory_text, $filename_text, $file_image_latest, $file_text_latest);
					# 
					$file_local = $dir . 'ftp_image.' . $$;
					&VERBOSE('detail', 'detail', 'SAVE(tmp): file = ' . $filename . ' -> ' . $file_local);
					open(FILE, ">$file_local");
					chmod(oct('600'), $file_local);
					binmode FILE;
					print FILE shift(@$ref_data);
					close(FILE);
					$flag = &FTP_SEND($flag, $ftp, $server, 'binary', $file_local, $directory_image, $filename_image);
					$flag = &FTP_SEND($flag, $ftp, $server, 'binary', $file_local, '', $file_image_latest);
					unlink($file_local);
					# ƥʬ
					$file_local = $dir . 'ftp_text.' . $$;
					&VERBOSE('detail', 'detail', 'SAVE(tmp): text -> ' . $file_local);
					open(FILE, ">$file_local");
					chmod(oct('600'), $file_local);
					print FILE &REMAKE_MAIL($ref_header, $ref_text);
					close(FILE);
					$flag = &FTP_SEND($flag, $ftp, $server, 'ascii', $file_local, $directory_text, $filename_text);
					unlink($file_local);
					if (($file_text_latest_template ne '') && ($file_text_latest ne '')) {
						# ƥʬ (SSI )
						$$ref_header{'X-CLIPPIC-MAILBODY'} = join("\n", @$ref_text);
						$ref_tmp = &REPLACE_STRING_HTML(&LOAD_TEMPLATE($setting{'dir_data'} . $file_text_latest_template), $ref_header);
						jcode::convert($ref_tmp, $file_text_latest_jcode, 'euc');
						$file_local = $dir . 'ftp_text_ssi.' . $$;
						&VERBOSE('detail', 'detail', 'SAVE(tmp): text -> ' . $file_local);
						open(FILE, ">$file_local");
						chmod(oct('600'), $file_local);
						print FILE $$ref_tmp;
						close(FILE);
						$flag = &FTP_SEND($flag, $ftp, $server, 'ascii', $file_local, '', $file_text_latest);
						unlink($file_local);
					}
				}
				&FTP_CLOSE($ftp);
			}
		} else {
			&VERBOSE('normal', 'normal', 'WARNING: there is no attachment file. / subject=' . $$ref_header{'SUBJECT'} . '; from=' . $$ref_header{'FROM'} . '; to=' . $$ref_header{'TO'} . ';');
		}
	}
	return($flag);
}



# : å
sub SECTION_RECEIVE_MAIL {
	my($ref_setting_mail, $dir) = @_;
	my($protocol, $server, $port, $username, $password, $delete);	# for POP
	my($file, $file_mail, $debug, $pop, $flag, $flag_auth);
	my($ref_uidl, $ref_uidl_new, $key, $ref_text, $line);
	my($counter, $counter_send);

	# ѿ
	$protocol = $$ref_setting_mail{'protocol:input'};
	$server = $$ref_setting_mail{'server:input'};
	$port = $$ref_setting_mail{'port:input'};
	$username = $$ref_setting_mail{'username:input'};
	$password = $$ref_setting_mail{'password:input'};
	$delete = $$ref_setting_mail{'delete:input'};
	if (($protocol eq 'pop') || ($protocol eq 'apop')) {
		&CHECK_MODULE('Net::POP3'); #<perl2exe_comment>
		# UIDL ե̾η
		&CHECK_DIR($dir, oct('700'));
		$file = $username . $server;
		$file =~ s/\W//g;
		$file =~ tr/A-Z/a-z/;
		$file = substr($file, 0, 12);
		$file = $dir . $file . '.dat';
		$file_mail = $dir . 'received.' . $$;
		$debug = int($setting{'verbose_level_stdout'} / 2);
		$flag = 'yes';
		&VERBOSE('normal', 'normal', 'CONNECT: protocol = ' . $protocol . '; server = ' . $server . '; username = ' . $username. ';');
		$pop = Net::POP3->new($server, Timeout => $setting{'seconds_net'}, Port => $port, Debug => $debug);
		if (!defined($pop)) {
			&VERBOSE('normal', 'normal', 'ERROR: cannot connect. / server = ' . $server);
			$flag = 'no';
		} else {
			if ($protocol eq 'apop') {
				$flag_auth = $pop->apop($username, $password);
				if (!defined($flag_auth)) {
					&VERBOSE('normal', 'normal', 'ERROR: authentication failed or APOP is not supported. / server = ' . $server . '; user = ' . $username . ';');
					$flag = 'no';
				}
			} else {
				$pop->user($username);
				$flag_auth = $pop->pass($password);
				if (!defined($flag_auth)) {
					&VERBOSE('normal', 'normal', 'ERROR: authentication failed. / server = ' . $server . '; user = ' . $username . ';');
					$flag = 'no';
				}
			}
			if ($flag eq 'yes') {
				$ref_uidl = $pop->uidl() || &VERBOSE('error', 'error', 'ERROR: UIDL is not supported? / server = ' . $server . '; user = ' . $username . ';');
				($ref_uidl_new, $counter) = &CHECK_UIDL($file, $ref_uidl);
				while (($key, undef) = each(%$ref_uidl_new)) {
					&VERBOSE('detail', 'detail', 'GET(pop,apop): No. = ' . $key . '; UIDL = ' . $$ref_uidl_new{$key} . ';');
					# ȥե
					open(FILE, ">$file_mail");
					chmod(oct('600'), $file_mail);
					$ref_text = $pop->get($key);
					while (@$ref_text) {
						$line = shift(@$ref_text);
						$line =~ s/^\.\././;
						print FILE $line;
					}
					close(FILE);
					# ᡼
					if (&SECTION_PROCESS_MAIL($file_mail, $ref_setting_mail, $dir) eq 'yes') {
						$counter_send ++;
					}
					unlink($file_mail);
				}
				$pop->quit();
			}
		}
		if (($setting{'cleanup_uidl'} >= 0) && ($counter > $setting{'cleanup_uidl'})) {
			&CLEANUP_UIDL($file, $setting{'cleanup_uidl'} / 2);
		}
		&SAVE_UIDL($file, $ref_uidl_new);
		if (($flag eq 'yes') && ($counter_send < 1)) {
			&VERBOSE('normal', 'normal', 'EXIT(pop,apop): new mail is not found.');
		}
	}
	if ($counter_send > 0) {
		$flag = 'yes';
	} else {
		$flag = 'no';
	}
	return($flag);
}



#=============================================================================

# ޥɥ饤󥪥ץɤ߼
sub READ_CMDLINE {
	my($ref_argv) = @_;
	my($counter, %output, $tmp1, $tmp2, $tmp3);

	for ($counter = 0; $counter < scalar(@$ref_argv); $counter ++) {
		$tmp1 = $$ref_argv[$counter];
		if ($tmp1 =~ /^-(.*)$/) {
			($tmp2, $tmp3) = split('=', $1, 2);
			if ($tmp3 eq '') {
				$tmp3 = 'yes';
			}
			$output{$tmp2} = $tmp3;
		}
	}
	return(\%output);
}



# ˤ뤫å (%check  %master ˤ뤫ɤ)
sub CHECK_DEFINITION {
	my($mode, $ref_master, $ref_check) = @_;
	my($key, $counter);

	while (($key, undef) = each(%$ref_check)) {
		if (!(defined($$ref_master{$key}))) {
			if (ref($mode)) {
				$mode = $$mode{$key};
			}
			&VERBOSE('normal', 'normal', 'WARNING: type miss? / key = ' . $key . ' (by '. $mode .')');
			$counter ++;
		}
	}
	if ($counter > 0) {
		&VERBOSE('error', 'error', 'ERROR: ' . $counter . ' syntax error(s) are found in some definition above.');
	}
	return;
}



# ᡼ե񤭽Ф
sub SAVE_CONFIGFILE_MAIL {
	my($file, $ref_exist_password) = @_;
	my($line, $key, $value, $file_rename, $code, $ref_text, $text_new, $flag_section);
	my($mode);

	# եɤ߹ߤʤ
	$file_rename = &LOCK_FILE($file);
	($ref_text, $code) = &LOAD_FILE($file_rename);
	$flag_section = 'no';
	while (@$ref_text) {
		$line = shift(@$ref_text);
		if ((!($line =~ /^\s*#/)) && (!($line =~ /^\s*$/))) {
			# # ǻϤޤäƤԡԤɤФ
			$line = ${&CUT_SPACE_TERMINAL(\$line)};
#			if ($line =~ /^\[(.*)_(\w+)\]$/) {
#				# [HOGEHOGE_???] ιԤ
			if ($line =~ /^\[(.*)\]$/) {
				# [HOGEHOGE] ιԤ
				$mode = $1;
				$mode =~ tr/A-Z/a-z/;
				if ($$ref_exist_password{$mode} eq 'yes') {
					# password ĤäƤ륻
					$flag_section = 'yes';
				} else {
					$flag_section = 'no';
				}
			} else {
				($key, $value) = split(/\s*=\s*/, $line, 2);
				$key =~ tr/A-Z/a-z/;
				if (($flag_section eq 'yes') && ($key eq 'password')) {
					$key = 'password_crypted';
					$value = &CRYPT_PASSWORD($value);
					$flag_section = 'done';
				} elsif ((($flag_section eq 'yes') || ($flag_section eq 'done')) && ($key eq 'password_crypted')) {
					next;
				}
				$line = $key . ' = ' . $value;
			}
		}
		$text_new .= $line . "\n";
	}
	# ե񤭽Ф
	open(FILE, ">$file_rename");
	chmod(oct('600'), $file_rename);
	jcode::convert(\$text_new, $code, 'euc');
	print FILE $text_new;
	close(FILE);
	&UNLOCK_FILE($file_rename);
	return;
}



# ǥ쥯ȥ¸ߤå (̵кäƤߤ)
sub CHECK_DIR {
	my($dir, $mode) = @_;

	if (!(-e $dir)) {
		$dir =~ s/\/$//;	#  Mac OS X + Perl 5.6.0 ǤϤʤưʤ
		mkdir($dir, $mode) || &VERBOSE('error', 'error', 'ERROR: cannot mkdir - dir = ' . $dir . ' (' . $mode . ')');
	}
	return;
}



# Ƽ⥸塼ɤ߹ߡСå򤹤
sub CHECK_MODULE {
	my($name) = @_;
	my($command, $version);

	if ($name eq 'Net::FTP') {
		if ($setting{'check_module_netftp'} ne 'done') {
			$version = &CHECK_MODULE_NUMERICAL($setting{'version_module_netftp'});
			if (($version - &CHECK_MODULE_NUMERICAL($Net::FTP::VERSION)) > 0) {
				&VERBOSE('error', 'error', 'ERROR: Net::FTP module must be newer than version ' . $version . '. / version = ' . $Net::FTP::VERSION);
			}
			$setting{'check_module_netftp'} = 'done';
		}
	} elsif ($name eq 'Net::POP3') {
		if ($setting{'check_module_netpop3'} ne 'done') {
			$version = &CHECK_MODULE_NUMERICAL($setting{'version_module_netpop3'});
			if (($version - &CHECK_MODULE_NUMERICAL($Net::POP3::VERSION)) > 0) {
				&VERBOSE('error', 'error', 'ERROR: Net::POP3 module must be newer than version ' . $version . '. / version = ' . $Net::POP3::VERSION);
			}
			$setting{'check_module_netpop3'} = 'done';
		}
	}
	return;
}
sub CHECK_MODULE_NUMERICAL {
	my($string) = @_;
	my($integer, $decimal);

	$string =~ /^(\d+)\.(.*)/;
	($integer, $decimal) = ($1, $2);
	$decimal =~ s/[^0-9]//g;
	return($integer . '.' . $decimal);
}



#  UIDL 򸫤Ĥ
sub CHECK_UIDL {
	my($file, $ref_uidl) = @_;
	my($counter, $key, $value, $line, %flag_new);
	my($file_rename);

	# ֤򥻥å
	while (($key, $value) = each(%$ref_uidl)) {
		$flag_new{$value} = 1;
	}
	# ɤȾȹ
	$file_rename = &LOCK_FILE($file);
	open(FILE, "$file_rename");
	while (defined($line = <FILE>)) {
		chop($line);
		if ($line ne '') {
			$flag_new{$line} = 0;
			$counter ++;
		}
	}
	close(FILE);
	&UNLOCK_FILE($file_rename);
	while (($key, $value) = each(%$ref_uidl)) {
		if ($flag_new{$value} == 0) {;
			delete($$ref_uidl{$key});
		}
	}
	return($ref_uidl, $counter);
}



# ɤ UIDL ¸
sub SAVE_UIDL {
	my($file, $ref_uidl) = @_;
	my($key, $value, $file_rename);

	$file_rename = &LOCK_FILE($file);
	open(FILE, ">>$file_rename");
	chmod(oct('600'), $file_rename);
	while (($key, $value) = each(%$ref_uidl)) {
		print FILE $value . "\n";
	}
	close(FILE);
	&UNLOCK_FILE($file_rename);
	return;
}



# UIDL եݽ
sub CLEANUP_UIDL {
	my($file, $counter_remain) = @_;
	my($file_rename, $file_tmp, $counter, $line);

	$file_rename = &LOCK_FILE($file);
	$file_tmp = $file . '.writing';
	open(FILE_UIDL1, "$file_rename");
	open(FILE_UIDL2, ">$file_tmp");
	chmod(oct('600'), $file_tmp);
	while (defined($line = <FILE_UIDL1>)) {
		$counter ++;
		if (($line ne '') && ($counter > $counter_remain)) {
			print FILE_UIDL2 $line;
		}
	}
	close(FILE_UIDL2);
	close(FILE_UIDL1);
	rename($file_tmp, $file);	# ξ̤ˡǥåե
	unlink($file_rename);
	&VERBOSE('normal', 'normal', 'CLEANUP(uidl): counter = ' . $counter_remain . '; file = ' . $file . ';');
	return;
}



# ᡼إåξå
sub CHECK_HEADER_CONDITION {
	my($ref_header, $line)= @_;
	my(@condition, $flag, $key, $value);

	$flag = 'yes';
	@condition = split(',', $line);
	while(@condition) {
		($key, $value) = split(':', shift(@condition), 2);
		$key = ${&CUT_SPACE_TERMINAL(\$key)};
		$key =~ tr/a-z/A-Z/;
		$value = ${&CUT_SPACE_TERMINAL(\$value)};
		if (!($$ref_header{$key} =~ /$value/i)) {
			$flag = 'no';
			last;
		}
	}
	return($flag);
}



# FTP ץ
sub FTP_OPEN {
	my($server, $port, $passive, $username, $password) = @_;
	my($ftp, $debug, $flag, $flag_auth);

	$debug = int($setting{'verbose_level_stdout'} / 2);
	if ($passive eq 'yes') {
		$passive = 1;
	} else {
		$passive = '';
	}
	$flag = 'yes';
	&VERBOSE('normal', 'normal', 'CONNECT: protocol = ftp; server = ' . $server . '; username = ' . $username. ';');
	$ftp = Net::FTP->new($server, Timeout => $setting{'seconds_net'}, Port => $port, Debug => $debug, Passive => $passive);
	if (!defined($ftp)) {
		&VERBOSE('normal', 'normal', 'ERROR: cannot connect. / server = ' . $server);
		$flag = 'no';
	} else {
		$flag_auth = $ftp->login($username, $password);
		if ($flag_auth == 0) {
			&VERBOSE('normal', 'normal', 'ERROR: authentication failed. / server = ' . $server . '; user = ' . $username . ';');
			$flag = 'no';
		}
	}
	return($flag, $ftp);
}



# FTP ե
sub FTP_SEND {
	my($flag, $ftp, $server, $mode, $file_local, $directory, $filename) = @_;
	my($flag_now) = 'yes';

	if ($filename ne '') {
		if ($mode eq 'ascii') {
			$ftp->ascii;
		} else {
			$ftp->binary;
		}
		if ($directory ne '') {
			$ftp->mkdir($directory);
			$ftp->cwd($directory);
			if (!defined($ftp)) {
				$flag = 'no';
				$flag_now = 'no';
				&VERBOSE('normal', 'normal', 'ERROR(ftp-mkdir): server = ' . $server . '; directory = ' . $directory);
			}
		}
		if (($directory eq '') || ($flag_now ne 'no')) {
			if (!($ftp->put($file_local, $filename))) {
#			if (!defined($ftp)) {
				$flag = 'no';
				&VERBOSE('normal', 'normal', 'ERROR(ftp-put): server = ' . $server . '; file = ' . $directory . $filename);
			} else {
				&VERBOSE('normal', 'normal', 'SEND(ftp): server = ' . $server . '; file = ' . $directory . $filename);
			}
		}
	}
	return($flag);
}



# FTP 
sub FTP_CLOSE {
	my($ftp) = @_;

	$ftp->quit;
	return;
}



# ᡼ (ƥʬΤ) ƹ
sub REMAKE_MAIL {
	my($ref_header, $ref_text) = @_;
	my($text, $key, $value, $date, $time);

	($date, $time) = &REMAKE_DATE($$ref_header{'DATE'});
	# clippic ѥեޥå
	$text .= <<_END_OF_TEXT_;
From: $$ref_header{'FROM'}
To: $$ref_header{'TO'}
Cc: $$ref_header{'CC'}
Date: $date $time
Subject: $$ref_header{'SUBJECT'}
_END_OF_TEXT_
	$text .= "\n";
#	# ᡼ΥեޥåȤۤܥե˺ƸϤ
#	while (($key, $value) = each(%$ref_header)) {
#		$text .= $key . ': ' . $value . "\n";
#	}
#	$text .= "\n";
	$text .= join("\n", @$ref_text);
	return($text);
}



# ִ
sub REPLACE_STRING_CONFIG {
	my($counter, $filename, $header_date, @text) = @_;
	my($date, $time, $date_yyyy, $date_mm, $date_dd, $time_hh, $time_nn, $time_ss);
	my($filename_1, $filename_2);
	my(%table);
	my($line, $key, $value, $part, $length, @text_new);

	# ִط
	($date, $time) = &REMAKE_DATE($header_date);
	$date =~ /(\d{4})\/(\d{2})\/(\d{2})/;
	($date_yyyy, $date_mm, $date_dd) = ($1, $2, $3);
	$time =~ /(\d{2}):(\d{2}):(\d{2})/;
	($time_hh, $time_nn, $time_ss) = ($1, $2, $3);
	# ե͡ط
	$filename =~ s/\///g;
	$filename =~ s/\.\.//g;
	$filename = &CONVERT_FILENAME($filename);
	$filename =~ tr/A-Z/a-z/;
	$filename =~ /(.*)\.(\w+)$/;
	$filename_1 = $1;
	$filename_2 = $2;
	# Ѵơ֥ѰդƤ
	%table = (
		'<YYYY>' => $date_yyyy,
		'<MM>' => $date_mm,
		'<DD>' => $date_dd,
		'<HH>' => $time_hh,
		'<NN>' => $time_nn,
		'<SS>' => $time_ss,
		'<FILENAME>' => $filename,
		'<FILENAME_1>' => $filename_1,
		'<FILENAME_2>' => $filename_2
	);
	while(@text) {
		$line = shift(@text);
		foreach $key (reverse(sort(keys(%table)))) {
			$value = $table{$key};
			$line =~ s/$key/$value/g;
		}
		if ($line =~ /<(#+)>/) {
			# ᡼ֹ
			$part = $1;
			$length = length($part);
			$part = sprintf('%0' . length($part) . 'd', $counter);
			$line =~ s/<(#+)>/$part/g;
		}
		if ($line =~ /<(\$+)>/) {
			# ץֹ
			$part = $1;
			$length = length($part);
			$part = sprintf('%0' . length($part) . 'd', $$);
			$line =~ s/<(\$+)>/$part/g;
		}
		push(@text_new, $line);
	}
	return($filename, @text_new);
}



# Mon, 20 Jan 2003 04:09:10 +0900פ2003/01/20 04:09:10פѴ (ȴ)
sub REMAKE_DATE {
	my($rfc_jst) = @_;
	my(@tmp, $date, $time);
	my(%month) = (
		'JAN' => '01',
		'FEB' => '02',
		'MAR' => '03',
		'APR' => '04',
		'MAY' => '05',
		'JUN' => '06',
		'JUL' => '07',
		'AUG' => '08',
		'SEP' => '09',
		'OCT' => '10',
		'NOV' => '11',
		'DEC' => '12'
	);

	@tmp = split(/\s+/, $rfc_jst);
	$tmp[2] =~ tr/a-z/A-Z/;
	$date = sprintf('%04d', $tmp[3]) . '/' . $month{$tmp[2]} . '/' . sprintf('%02d', $tmp[1]);
	$time = $tmp[4];
	return($date, $time);
}



# ե̾򥳥СȤ (<http://www.din.or.jp/~ohzaki/perl.htm#JP_Escape> 򻲹)
sub CONVERT_FILENAME {
	my($text) = @_;

#	$text =~ s/([^\w ])/'%' . unpack('H2', $1)/eg;
#	$text =~ tr/ /+/;
	$text =~ s/([^~\w\-\.])/'%' . unpack('H2', $1)/eg;
	$text =~ tr/ /+/;
	return($text);
}



# ᡼뤫ƥʬźդ줿եȴФ
sub EXTRACT_PLAINTEXT_ATTACHMENT {
	my($ref_header, $ref_text, $address_regex, $ref_filename, $ref_data) = @_;
	my($ref_part, $boundary, $part, @part, @text_new, $data);

	# źեեȤ̾Ф
	if ($$ref_header{'CONTENT-TYPE'} =~ /^image\//i) {
		$data = ${&DECODE_MIME_DATA($ref_header, $ref_text)};
		if (($$ref_header{'CONTENT-TYPE'} =~ /name\s*=\s*"?([^";]+)"?/i) || ($$ref_header{'CONTENT-DISPOSITION'} =~ /filename\s*=\s*"?([^";]+)"?/i)) {
			push(@$ref_filename, &DECODE_MIME_LINE($1));
			push(@$ref_data, $data);
			&VERBOSE('detail', 'detail', 'FIND(mail_file): filename = ' . $1 . '; byte = ' . length($data));
		}
	} else {
		# Content-Type å
		if (($$ref_header{'CONTENT-TYPE'} eq '') || ($$ref_header{'CONTENT-TYPE'} =~ /^text\/plain/i)) {
			@part = split("\n", ${(&CONVERT_EUC(&DECODE_MIME_DATA($ref_header, $ref_text)))[0]});
			$ref_text = \@part;
			push(@text_new, @$ref_text);
		} elsif ($$ref_header{'CONTENT-TYPE'} =~ /boundary\s*=\s*"?([^";\s]+)"?/i) {
			# boundary ꤬
			$boundary = $1;
			&VERBOSE('detail', 'detail', 'FIND(multipart): boundary = ' . $boundary);
			$ref_part = &EXTRACT_MULTIPART($ref_text, $boundary);
			while (@$ref_part) {
				$part = shift(@$ref_part);
				if ($part ne '') {
					@part = split("\n", $part);
					($ref_text, $ref_filename, $ref_data) = &EXTRACT_PLAINTEXT_ATTACHMENT((&EXTRACT_HEADER(\@part, $address_regex)), $address_regex, $ref_filename, $ref_data);
					push(@text_new, @$ref_text);
				}
			}
		}
	}
	return(\@text_new, $ref_filename, $ref_data);
}



# quoted-printable, base64 ǥɤ
sub DECODE_MIME_DATA {
	my($ref_header, $ref_text) = @_;
	my($encoding, $data);

	$encoding = $$ref_header{'CONTENT-TRANSFER-ENCODING'};
	$encoding =~ tr/A-Z/a-z/;
	if ($encoding eq 'quoted-printable') {
		$data = &bodydecode(join("\n", @$ref_text), 'qp');	# mimer.pl
	} elsif ($encoding eq 'base64') {
		$data = &bodydecode(join("\n", @$ref_text), 'b64');	# mimer.pl
	} else {
		$data = join("\n", @$ref_text);
	}
	&bdeflush;
	return(\$data);
}



# ᡼إåȴФ
sub EXTRACT_HEADER {
	my($ref_text, $address_regex) = @_;
	my($counter, @text, $line, %header, $text, @body, $key, $value);
	my(@header, @address);

	for ($counter = 0; $counter < scalar(@$ref_text); $counter ++) {
		#  or "--------" (for ſȬ᡼ե) ǲϽλ
		if (($$ref_text[$counter] eq '') || ($$ref_text[$counter] eq '--------')) {
			last;
		}
	}
	$text = join("\n", splice(@$ref_text, 0, $counter));
	$text =~ s/\n\s+/ /g;
	@text = split("\n", $text);
	@body = splice(@$ref_text, 1);
	while (@text) {
		($key, $value) = split(':', shift(@text), 2);
		$key =~ tr/a-z/A-Z/;
		$value = ${&CUT_SPACE_TERMINAL(\$value)};
		if (exists($header{$key}) && ($key ne 'RECEIVED')) {
			$header{$key} = $value . "\t" . $header{$key};
		} else {
			$header{$key} = $value;
		}
	}
	# Subject  MIME ǥ
	if (exists($header{'SUBJECT'})) {
		$header{'X-ORIGINAL-SUBJECT'} = $header{'SUBJECT'};
		$header{'SUBJECT'} = &DECODE_MIME_LINE($header{'SUBJECT'});
	}
	# ᡼륢ɥ쥹
	@header = ('FROM', 'TO', 'CC');
	while (@header) {
		$key = shift(@header);
		if (exists($header{$key})) {
			$header{'X-ORIGINAL-' . $key} = $header{$key};
			$line = $header{$key};
			@address = ();
			while ($line =~ /($address_regex)/o) {
				$value = $1;
				if ((!($line =~ /"\s*$value\s*"/)) && (!($line =~ /\(\s*$value\s*\)/))) {
					# ᡼륢ɥ쥹餷Τ ""  () ˰ϤޤƤʤä
					push(@address, $value);
				}
				$value = quotemeta($value);
				$line =~ s/$value//;
			}
			$header{$key} = join(',', @address);
		}
	}
	return(\%header, \@body);
}



# ѥɤ򾯤ФŹ沽ƤĤ
sub CRYPT_PASSWORD {
	my($line) = @_;

	$line = &MIME::base64encode(unpack('h*', ~ unpack('H*', ~ $line)));
	return($line);
}



# ѥɤ沽
sub DECRYPT_PASSWORD {
	my($line) = @_;

	$line = ~ pack('H*', ~ pack('h*', &MIME::base64decode($line)));
	return($line);
}



# ǥɤ (: [skypl:2420,2428] ĽꤵΥ)
sub DECODE_MIME_LINE {
	my($line) = @_;
	my($pattern_base64_sjis) = '=\?shift_jis\?B\?([a-z0-9\+\/]+)=*\?=';
	my($pattern_base64_euc) = '=\?euc_jp\?B\?([a-z0-9\+\/]+)=*\?=';
	my($pattern_qp_jis) = '=\?iso-2022-jp\?Q\?(.+)=*\?=';

	if ($line =~ /$pattern_base64_sjis/io) {
		# Shift_JIS (B)
		$line =~ s/$pattern_base64_sjis/&MIME::base64decode($1)/gieo;	# mimer.pl
		jcode::sjis2euc(\$line, 'z');
	} elsif ($line =~ /$pattern_base64_euc/io) {
		# EUC-JP (B)
		$line =~ s/$pattern_base64_euc/&MIME::base64decode($1)/gieo;	# mimer.pl
	} elsif ($line =~ /$pattern_qp_jis/io) {
		# JIS (Q)
		$line =~ s/$pattern_qp_jis/&MIME::qpdecode($1)/gieo;	# mimer.pl
		jcode::jis2euc(\$line, 'z');
	} else {
		# ֤ JIS (B)
		$line = &mimedecode($line, 'EUC');	# mimer.pl
	}
	return($line);
}



# multipart ʬ䤹
sub EXTRACT_MULTIPART {
	my($ref_text, $boundary) = @_;
	my(@part, $boundary_last);

	$boundary = '--' . quotemeta($boundary);
	$boundary_last = $boundary . '--';
	@part = split($boundary . "\n", join("\n", @$ref_text));
	$part[$#part] =~ s/$boundary_last$//;
	return(\@part);
}
